#include <iostream>
#include <vector>
#include <string>
#include <map>
using namespace std ;
typedef long long ll ;
/*
 *   This should be pretty easy.  Our states are a single vector of
 *   values (edit distances up to the max+1), the transitions are
 *   letters, etc.  Once we have the automata we can walk it and
 *   count it.  We give each state a number (starting with zero)
 *   and build a state x element transition matrix.
 */
const ll MOD = 998244353 ;
int main(int argc, char *argv[]) {
   int verbose = argc > 1 ;
   int n ;
   string s ;
   cin >> s >> n ;
   map<vector<char>, int> statemap ;
   vector<vector<int> > trans ;
   vector<int> empty(26) ;
   int nstates = 0 ;
   vector<char> state0 ;
   vector<vector<char> > statelist ;
   for (int i=0; i<(int)s.size()+1; i++)
      state0.push_back(i) ;
   statemap[state0] = nstates++ ;
   statelist.push_back(state0) ;
   vector<char> ts ;
   for (int sn=0; sn<nstates; sn++) {
      vector<char> fs = statelist[sn] ;
      trans.push_back(empty) ;
      for (int c='A'; c<='Z'; c++) {
         ts.clear() ;
         ts.push_back(fs[0]+1) ;
         for (int si=0; si<(int)s.size(); si++)
            ts.push_back(min(fs[si+1]+1, min(ts[si]+1, fs[si]+(c!=s[si])))) ;
         for (auto &v : ts)
            v = min(v, (char)(n+1)) ;
         auto it = statemap.find(ts) ;
         int s2 = nstates ;
         if (it == statemap.end()) {
            statemap[ts] = nstates++ ;
            statelist.push_back(ts) ;
         } else {
            s2 = it->second ;
         }
         trans[sn][c-'A'] = s2 ;
      }
   }
   if (verbose)
      cout << "s " << s.size() << " n " << n << " state count is " << nstates << endl ;
/*
 *   Now compute the total number of strings at edit distance
 *   exactly n.  The length of such a string is at most
 *   the input string plus n.
 */
   ll sum = 0 ;
   vector<ll> cnt(nstates) ;
   cnt[0] = 1 ;
   for (int len=0; len<=(int)s.size()+n; len++) {
      for (int i=0; i<nstates; i++)
         if (cnt[i] && statelist[i][s.size()] == n)
            sum = (sum + cnt[i]) % MOD ;
      if (len == (int)s.size()+n)
         break ;
      vector<ll> cnt2(nstates) ;
      for (int i=0; i<nstates; i++)
         if (cnt[i])
            for (int c=0; c<26; c++)
               cnt2[trans[i][c]] = (cnt2[trans[i][c]] + cnt[i]) % MOD ;
      swap(cnt, cnt2) ;
   }
   cout << sum << endl ;
}
