#include <algorithm>
#include <bitset>
#include <cassert>
#include <chrono>
#include <cstring>
#include <iomanip>
#include <iostream>
#include <map>
#include <queue>
#include <random>
#include <set>
#include <stack>
#include <vector>

using namespace std;

const int MOD = 998244353 ;

string s;

void iterate(vector<int>& before, vector<int>& after, char ch) {
  assert(before.size() == after.size());
  for(int i = 0; i < after.size(); i++) {
    after[i] = before[i]+1;
    if(i > 0) {
      after[i] = min(after[i], after[i-1] + 1);
      if(s[i-1] == ch) {
        after[i] = min(after[i], before[i-1]);
      }
      else {
        after[i] = min(after[i], before[i-1] + 1);
      }
    }
  }
}

void solve() {
  int desire;
  cin >> s;
  cin >> desire;
  map<vector<int>, int> dp;
  {
    vector<int> seed;
    for(int i = 0; i <= s.size(); i++) seed.push_back(i);
    dp[seed]++;
  }
  int ret = 0;
  for(int len = 0; len <= s.size() + desire; len++) {
    map<vector<int>, int> ndp;
    for(auto out: dp) {
      vector<int> src = out.first;
      if(src[s.size()] == desire) {
        ret += out.second;
        ret %= MOD;
      }
      for(char ch = 'A'; ch <= 'Z'; ch++) {
        vector<int> cand;
        cand.resize(src.size());
        iterate(src, cand, ch);
        ndp[cand] += out.second;
        ndp[cand] %= MOD;
      }
    }
    dp = ndp;
  }
  cout << ret << "\n";
}

int main() {
  solve();
}
