#!/usr/bin/env python3
import string
import sys

from collections import defaultdict

MOD = 998244353

input = sys.stdin.readline

def main():
    s, d = input().split()
    d = int(d)
    n = len(s)

    ans = 0

    # map state to count
    # state is a tuple: (len, dp row)
    # if last element in the row == d, then add count
    dp = {tuple(range(n + 1)): 1}
    for _ in range(n + d + 1):
        ndp = defaultdict(int)
        for row, freq in dp.items():
            if row[-1] == d:
                ans += freq
                if ans >= MOD:
                    ans -= MOD
            for c in string.ascii_uppercase:
                new_row = [x + 1 for x in row]
                for i in range(1, n + 1):
                    new_row[i] = min(new_row[i], new_row[i - 1] + 1, row[i - 1] + (0 if s[i - 1] == c else 1))
                state = tuple(new_row)
                ndp[state] += freq
                if ndp[state] >= MOD:
                    ndp[state] -= MOD
        dp = ndp

    print(ans)

if __name__ == '__main__':
    main()
